﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;
using Syncfusion.Pdf.Graphics;
using System.IO;
using System.Diagnostics;

namespace DigitalSignatureSample
{
    class Program
    {
        static void Main(string[] args)
        {
           
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument("../../Data/Input.pdf");

            //Gets the first page of the document
            PdfLoadedPage page = loadedDocument.Pages[0] as PdfLoadedPage;

            //Gets the first signature field of the PDF document
            PdfLoadedSignatureField signatureField1 = loadedDocument.Form.Fields[0] as PdfLoadedSignatureField;
            
            //Creates a certificate
            PdfCertificate certificate1 = new PdfCertificate("../../Data/PDF.pfx", "syncfusion");
            signatureField1.Signature = new PdfSignature(loadedDocument, page, certificate1, "Student Signature", signatureField1);
            FileStream imageStream = new FileStream("../../Data/logo.png", FileMode.Open, FileAccess.Read);
          
            //Draw image
            PdfBitmap signatureImage = new PdfBitmap(imageStream);
            signatureField1.Signature.Appearance.Normal.Graphics.DrawImage(signatureImage, 0, 0, 90, 20);
            signatureField1.Signature.DocumentPermissions = PdfCertificationFlags.AllowFormFill;

            //Save the document into stream
            MemoryStream stream = new MemoryStream();
            loadedDocument.Save(stream);
            
            //Load the signed PDF document
            PdfLoadedDocument signedDocument = new PdfLoadedDocument(stream);
           
            //Load the PDF page
            PdfLoadedPage loadedPage = signedDocument.Pages[0] as PdfLoadedPage;
            
            //Gets the seocnd signature field of the PDF document
            PdfLoadedSignatureField signatureField2 = signedDocument.Form.Fields[1] as PdfLoadedSignatureField;
            signatureField2.Signature = new PdfSignature(signedDocument, loadedPage, certificate1, "Signature", signatureField2);           

            //Saving the PDF 
            signedDocument.Save("Sample.pdf");
            signedDocument.Close(true);

            Process.Start("Sample.pdf");        
        }
    }
}
